(***********************************************
 *                                             *
 *              CS520 Fall 2006                *
 *           Programming Assignment            *
 *         Computer Science Department         *
 *             Boston University               *
 *                                             *
 ***********************************************)

open Format
open Support.Error
open Support.Pervasive

type term0 =
    TmVar0 of string
  | TmLam0 of string * term0
  | TmApp0 of term0 * term0

let rec printtm0 t = 
  match t with
    TmVar0 v -> pr ("TmVar \"" ^ v ^ "\"")
  | TmLam0 (v, t') -> 
      pr ("TmLam (\"" ^ v ^ "\", "); 
      printtm0 t';
      pr (")")
  | TmApp0 (t1, t2) -> 
      pr ("TmApp ("); 
      printtm0 t1;
      pr (", ");
      printtm0 t2;
      pr (")")  

let printtm t = printtm0 t; pr ("\n");







