(***********************************************
 *                                             *
 *              CS520 Fall 2006                *
 *           Programming Assignment            *
 *         Computer Science Department         *
 *             Boston University               *
 *                                             *
 ***********************************************)

(* module Syntax: syntax trees and associated support functions *)

open Support.Pervasive
open Support.Error

(* Abstract Syntax Tree (AST) definitions *)
type term0 =
    TmVar0 of string
  | TmLam0 of string * term0
  | TmApp0 of term0 * term0

(* Printing *)
val printtm: term0 -> unit



